#include "main.h"

int main(int argc, char *argv[])
{
    int continuer = 1, i = 0, j = 0, nombreDeCorp = 8, direction = BAS;
    int gameOver = 0, pomme = 0, nBreDePommeMangees = 0;
    int enPause = 0;
    SDL_Event event;
    SDL_Surface *ecran = NULL, *imageSerpent = NULL;
    SDL_Surface *surfaceGameOver = NULL, *imagePomme = NULL;
    SDL_Rect positionSerpent[1000], positionPomme, positionAutresElements;
    int tempsActuel = 0, tempsPrecedent = 0, vitesse = 500;

    //Initialisation de la SDL
    if(SDL_Init(SDL_INIT_VIDEO) < 0)
    {
        fprintf(stderr,"Impossible d'initialiser la SDL");
        exit(EXIT_FAILURE);
    }

    ecran = SDL_SetVideoMode(LARGEUR_ECRAN,HAUTEUR_ECRAN,NBRE_DE_BIT,SDL_HWSURFACE | SDL_DOUBLEBUF);
    if(ecran == NULL)
    {
        fprintf(stderr,"Impossible d'ouvrir la fenetre");
        exit(EXIT_FAILURE);
    }

    //On donne un titre  la fenetre
    SDL_WM_SetCaption("Serpent en SDL",NULL);

    /* CHARGEMENT DES IMAGES */

    //L'image de la pomme
    imagePomme = IMG_Load("images/pomme.gif");
    //Le corps du serpent
    imageSerpent = IMG_Load("images/corp_serpent.gif");
    if(imageSerpent == NULL)
    {
        fprintf(stderr,"Impossible de charger le corp du serpent");
        exit(EXIT_FAILURE);
    }

    /* ON GERE LA TRANSPARENCE */

    //De la pomme
    SDL_SetColorKey(imagePomme,SDL_SRCCOLORKEY,SDL_MapRGB(imagePomme->format,255,0,0));

    //Du serpent
    SDL_SetColorKey(imageSerpent,SDL_SRCCOLORKEY,SDL_MapRGB(imageSerpent->format,255,0,0));

    //On fait une boucle pour positionner tout les parties du serpent
    positionSerpent[0].x = ecran->w/2;
    positionSerpent[0].y = 135;

    for(i=1;i <= nombreDeCorp;i++)
    {
        positionSerpent[i].x = ecran->w/2;
        positionSerpent[i].y = 150 - (15*i);
    }

    while(continuer)
    {
        while(SDL_PollEvent(&event))
        {
            switch(event.type)
            {
                case SDL_QUIT:
                    continuer = 0; //On quitte le programme
                    break;

                case SDL_KEYDOWN:
                    switch(event.key.keysym.sym)
                    {
                        case SDLK_ESCAPE:
                            continuer = 0; //On quit le programme aussi
                            break;

                        case SDLK_DOWN:
                            direction = BAS;
                            break;

                        case SDLK_UP:
                            direction = HAUT;
                            break;

                        case SDLK_RIGHT:
                            direction = DROITE;
                            break;

                        case SDLK_LEFT:
                            direction = GAUCHE;
                            break;

                        case SDLK_RETURN:
                            if(!enPause)
                            {
                                //enPause = 1 (le jeu est en pause :p)
                                enPause = 1;
                            }
                            else //Sa veut dire que enPause = 1
                            {
                                //On dis que le jeu n'est plus en pause :)
                                enPause = 0;
                            }
                            break;

                    }//Fin du switch(event.key.keysym.sym)
                    break;

            }//Fin du switch (event.type)

        }//Fin du while(SDL_PollEvent(event.type))

        /* GESTION DU TEMPS */

        //On regarde si la vitesse n'est pas ngative
        if(!enPause)
        {
            tempsActuel = SDL_GetTicks();
            if((tempsActuel - tempsPrecedent) > vitesse)
            {
                //On appelle une fonction pour dplacer le serpent
                deplacerSerpent(direction,positionSerpent,&positionPomme,nombreDeCorp,&pomme);

                tempsPrecedent = tempsActuel; //On remet tempsPrecedent  0

            }//Fin du if((tempsActuel - tempsPrecedent) > vitesse)

        }//Fin du if(vitesse > 0)

        //Si il y a une pomme sur le terrain
        if(pomme)
        {
            //On regarde si le serpent n'a pas mang la pomme :)
            if(positionSerpent[0].x == positionPomme.x && positionSerpent[0].y == positionPomme.y)
            {
                //On fait sa pour crer une nouvelle pomme
                pomme = 0;

                //On agrandit le serpent
                nombreDeCorp++;

                //On incrmente nBreDePommeMangees
                nBreDePommeMangees++;

                //On augmente la vitesse de dplacement du serpent
                vitesse -= 20;
            }
        }//Fin du if(pomme)

        //On regarde si il y a une pomme sur le terrain
        if(!pomme)
        {
            srand(time(NULL));
            //On place une nouvelle pomme
            do
            {
                /* Je fais sa pour viter que la pomme soit choisit l
                o il y a le serpent, comme sa on est sur que la pomme
                ne sera jamais cach par le serpent ! */
                positionPomme.x = (rand() % (LARGEUR_ECRAN / 15)) * 15;
                positionPomme.y = (rand() % (HAUTEUR_ECRAN / 15)) * 15;
            }while(pommeDansSerpent(positionPomme.x,positionPomme.y,nombreDeCorp,&positionSerpent) < 1);

            /*
            Mon ancien code (au cas o) :
            positionPomme.x = (rand() % 20) * 15;
            positionPomme.y = (rand() % 20) * 15;
            */

            //Il y a donc une pomme sur le terrain
            pomme = 1;
        }

        if(vitesse <= 220)
        {
            //Comme sa on es sur que la vitesse ne descendra pas en
            //dessous de 200 !
            vitesse = 220;
        }

        //On teste si la pomme n'est pas sous le serpent
        for(i=0;i <= nombreDeCorp;i++)
        {
            if(positionSerpent[i].x == positionPomme.x && positionSerpent[i].y == positionPomme.y)
            {
                pomme = 0;
            }

        }

        //Maintenant on test si le serpent ne se passe pas dessus
        for(i = 1 ; i <= nombreDeCorp ; i++)
        {
            //Si le serpent se passe dessus
            if(positionSerpent[0].x == positionSerpent[i].x && positionSerpent[0].y == positionSerpent[i].y)
            {
                //Dans ce cas l on lui dit qu'il a perdu
                gameOver = 1;
            }//Fin du if
        }//fin du for

        //Si le joueur a perdu (gameOver = 1)
        if(gameOver)
        {
            //On crer le rectangle
            surfaceGameOver = SDL_CreateRGBSurface(SDL_HWSURFACE,LARGEUR_CADRE_GAMEOVER,HAUTEUR_CADRE_GAMEOVER,NBRE_DE_BIT,0,0,0,0);

            //On colorie le rectangle
            SDL_FillRect(surfaceGameOver,NULL,SDL_MapRGB(surfaceGameOver->format,0,0,200));

            //On positionne le carr
            positionAutresElements.x = (ecran->w/2) - (LARGEUR_CADRE_GAMEOVER / 2);
            positionAutresElements.y = (ecran->h/2) - (HAUTEUR_CADRE_GAMEOVER / 2);

            //Et on blit :)
            SDL_BlitSurface(surfaceGameOver,NULL,ecran,&positionAutresElements);
        }

        //On efface l'ecran
        SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,185,231));


        //On blit la pomme
        SDL_BlitSurface(imagePomme,NULL,ecran,&positionPomme);

        //On blit le serpent (boucle)
        for(i=0;i <= nombreDeCorp;i++)
        {
            SDL_BlitSurface(imageSerpent,NULL,ecran,&positionSerpent[i]);
        }

        //On actualise l'ecran
        SDL_Flip(ecran);

    }//Fin du while(continuer)

    //On libre toutes les surfaces alloues manuellement
    SDL_FreeSurface(surfaceGameOver);
    SDL_FreeSurface(imageSerpent);


    SDL_Quit();

    return EXIT_SUCCESS;
}

/* LES FONCTIONS */

void deplacerSerpent(int direction, SDL_Rect positionSerpent[], SDL_Rect *positionPomme, int nombreDeCorp, int *pomme)
{
    int i = 0;
    if(direction == BAS) //Si le serpent va vers le bas
    {
        positionSerpent[0].y += HAUTEUR_SPRITE;
        if(positionSerpent[0].y >= HAUTEUR_ECRAN)
        {
            positionSerpent[0].y = 0;
        }
    }

    if(direction == HAUT) //Si le serpent va vers le bas
    {
        positionSerpent[0].y -= HAUTEUR_SPRITE;
        if(positionSerpent[0].y < 0)
        {
            positionSerpent[0].y = HAUTEUR_ECRAN;
        }
    }

    if(direction == DROITE) //Si le serpent va vers le bas
    {
        positionSerpent[0].x += HAUTEUR_SPRITE;
        if(positionSerpent[0].x >= LARGEUR_ECRAN)
        {
            positionSerpent[0].x = 0;
        }
    }

    if(direction == GAUCHE) //Si le serpent va vers le bas
    {
        positionSerpent[0].x -= HAUTEUR_SPRITE;
        if(positionSerpent[0].x < 0)
        {
            positionSerpent[0].x = LARGEUR_ECRAN;
        }
    }

    //On modifie les coordonnes des autres parties du corp
    for(i = nombreDeCorp; i >= 1; i--)
    {
        positionSerpent[i].x = positionSerpent[i - 1].x;
        positionSerpent[i].y = positionSerpent[i - 1].y;
    }//Fin du for
}

int pommeDansSerpent(int X, int Y, int nombreDeCorp, SDL_Rect positionSerpent[])
{
    int i = 0;
    for(i=0;i <= nombreDeCorp;i++)
    {
        if ((positionSerpent[i].x == X) && (positionSerpent[i].y == Y))
            //Sa veut dire que la pomme est sur le serpent
            return 0;
    }
    //On retourne 1 (car c'est bon)
    return 1;
}